%15 

%       
%  f(x)=

%     
close all
%    (WORKSPACE)
clear

%  INLINE- fline, ..  , 
%      
%  f(x)=P1*exp(-P1*x), x>0; P1=lambda -  -.
%  "-"       , 
%        FMIN

%t -   
fline=inline('-x/(t*t).*exp((-x.*x-mm*mm)/2/t/t).*BESSELI(0,mm*x/t/t)','x','mm','t');

mm=1;
t=1;
N=50000;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                    %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% a -      
a=0;
%% b -      
b=10;
%        0 10 10!
%  ,     
%     . 
%   FMIN.
Xmax=fminbnd(fline,a,b,[],mm,t);
% Fmax -      
Fmaxbnd=-feval(fline,Xmax,mm,t);
% n -       
n=1;
% nn -       
nn=1;
% ,    
while n<=N
   xi1=a+(b-a)*rand(1,1);% xi1 - 1-  
   xi2=Fmaxbnd*rand(1,1);   % xi2 - 2-  
   if xi2<=-feval(fline,xi1,mm,t) %   xi2 <= f(xi1)
      eta(n)=xi1; %  
      n=n+1;      %    
   end;
   nn=nn+1;       %    
end;
%    nn  n
[nn n]

x=(a:0.1:b);

%   
% f_est2 -   
f_est2=hist(eta,x);
f_est2=f_est2/(N*(x(2)-x(1)));



figure(1)
%  
plot(x,-feval(fline,x,mm,t),x,f_est2);

%   
title('Modeling results(Neiman)...')
%   
xlabel('y')
%   
ylabel('f(y)')
%  
grid


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                   %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% a -      
a=0;
%% b -      
b=10;
% K -         
% ,       .
K=50;
% p -          
p=1/K;
% X -  ,   
 X(1)=a;
%      X
for k=2:K+1
pred=0;
X(k)=X(k-1);
 while pred<p
   X(k)=X(k)+0.0001;
    pred=pred-(feval(fline,X(k-1),mm,t)+feval(fline,X(k),mm,t))*0.0001/2;
end;
end;
%        
for n=1:N
   xi1=rand(1,1);% xi1 - 1-  
   k=round((K-1)*xi1)+1;% k -    
   xi2=rand(1,1);% xi2 - 2-  
   eta(n)=X(k)+xi2*(X(k+1)-X(k));%    
end;

%   
% f_est3 -   
f_est3=hist(eta,x);
f_est3=f_est3/(N*(x(2)-x(1)));


figure(2)
%  
plot(x,-feval(fline,x,mm,t),x,f_est3);

%   
title('Modeling results(Buslenko)...')
%   
xlabel('y')
%   
ylabel('f(y)')
%  
grid